#ifndef SCALARFIELD_H
#define SCALARFIELD_H

#include <types.h>
#include <math/vector.h>

typedef float (*potential_f)( float x, float y, float z, void const* arg );

typedef struct {
	float		potential;
	Vector3f	position;
} ScalarFieldVertex;

typedef struct {
	ScalarFieldVertex*	verts;
	uint16_t			width;
	uint16_t			height;
	uint16_t			depth;
} ScalarField;

void init_ScalarField( ScalarField* self, uint16_t width, uint16_t height, uint16_t depth );
uint16_t getWidth_ScalarField( ScalarField const* self );
uint16_t getHeight_ScalarField( ScalarField const* self );
uint16_t getDepth_ScalarField( ScalarField const* self );
ScalarFieldVertex* getAtGrid_ScalarField( ScalarField const* self, uint16_t i, uint16_t j, uint16_t k );
void calculate_ScalarField( ScalarField* self, potential_f potential, void const* potential_arg );

#endif	/* SCALARFIELD_H */
