#include "Cell.h"

typedef struct {
	uint8_t	a, b;
} uint8_tPair;

static const uint8_tPair edges[] = {
	{ 0, 1 },	// 0
	{ 1, 2 },	// 1
	{ 2, 3 },	// 2
	{ 3, 0 },	// 3
	{ 4, 5 },	// 4
	{ 5, 6 },	// 5
	{ 6, 7 },	// 6
	{ 7, 4 },	// 7
	{ 0, 4 },	// 8
	{ 1, 5 },	// 9
	{ 2, 6 },	// A
	{ 3, 7 }	// B
};

void init_Cell( Cell* self, ScalarField const* scalarField, uint16_t i, uint16_t j, uint16_t k ) {
	self->verts[0] = getAtGrid_ScalarField( scalarField, i, j, k );
	self->verts[1] = getAtGrid_ScalarField( scalarField, i + 1, j, k );

	self->verts[2] = getAtGrid_ScalarField( scalarField, i + 1, j + 1, k );
	self->verts[3] = getAtGrid_ScalarField( scalarField, i, j + 1, k );

	self->verts[4] = getAtGrid_ScalarField( scalarField, i, j, k + 1 );
	self->verts[5] = getAtGrid_ScalarField( scalarField, i + 1, j, k + 1 );

	self->verts[6] = getAtGrid_ScalarField( scalarField, i + 1, j + 1, k + 1 );
	self->verts[7] = getAtGrid_ScalarField( scalarField, i, j + 1, k + 1 );
}

inline CellEdge getEdge_Cell( Cell const* self, uint8_t edgeIndex ) {
	CellEdge edge;
	edge.verts[0] = self->verts[ edges[ edgeIndex ].a ];
	edge.verts[1] = self->verts[ edges[ edgeIndex ].b ];

	return edge;
}
