#include "ScalarField.h"
#include <malloc.h>

void init_ScalarField( ScalarField* self, uint16_t width, uint16_t height, uint16_t depth ) {
	self->width = width;
	self->height = height;
	self->depth = depth;
	self->verts = malloc( sizeof( *self->verts ) * width * height * depth );
}

inline uint16_t getWidth_ScalarField( ScalarField const* self ) {
	return self->width;
}

inline uint16_t getHeight_ScalarField( ScalarField const* self ) {
	return self->height;
}

uint16_t getDepth_ScalarField( ScalarField const* self ) {
	return self->depth;
}

inline ScalarFieldVertex* getAtGrid_ScalarField( ScalarField const* self, uint16_t i, uint16_t j, uint16_t k ) {
	return &self->verts
	[
		self->width * self->height * k +
		self->width * j +
		i
	];
}

void calculate_ScalarField( ScalarField* self, potential_f potential, void const* potential_arg ) {
	ScalarFieldVertex* vertex = self->verts;

	float dx = 1.0f / (self->width - 1);
	float dy = 1.0f / (self->height - 1);
	float dz = 1.0f / (self->depth - 1);

	float z = -0.5f;
	for( int k=0; k<self->depth; ++k, z+=dz ) {
		float y = -0.5f;
		for( int j=0; j<self->height; ++j, y+=dy ) {
			float x = -0.5f;
			for( int i=0; i<self->width; ++i, x+=dx ) {
				vertex->potential = potential( x, y, z, potential_arg );
				init_Vector3f( &vertex->position, x, y, z );
				++vertex;
			}
		}
	}
}
