#ifndef ACTION_H
#define ACTION_H

#include <sys/time.h>
#include <types.h>

typedef void (*actionf)( Time const* time, void* arg );
typedef void (*initf)( Time const* time, void* arg );

typedef struct {
	initf		init_func;
	actionf		action_func;
	void*		arg;
	Time		timeStart;
	Time		timeDuration;
	bool		initialized;
} Action;

void init_Action( Action* action,
	initf init_func,
	actionf action_func,
	void* farg,
	Time timeStart,
	Time timeDuration
);

#endif	/* ACTION_H */

