#ifndef LAYER_H
#define LAYER_H

#include <types.h>
#include <containers/vec_.h>
#include <vertex.h>
#include <triangle.h>

typedef Vertex_pos3f_col4f_n3f_tc2f Vertex_generic;

typedef struct {
	uint16_t	material_id;
	Vec			verts;			// Vec(Vertex_generic)
	Vec			triangles;		// Vec(Triangle)
} Layer;

void init_Layer( Layer* self );
void destroy_Layer( Layer* self );
void reset_Layer( Layer* self );
uint16_t getMaterialId_Layer( Layer const* self );
void setMaterialId_Layer( Layer* self, uint16_t material_id );
void addVertex_Layer( Layer* self, Vertex_generic const* vertex );
void addTriangle_Layer( Layer* self, Triangle const* triangle );
Vec const* getVerticesConst_Layer( Layer const* self );
Vec const* getTrianglesConst_Layer( Layer const* self );

#endif	/* LAYER_H */
