#ifndef VECTOR_H
#define VECTOR_H

typedef struct {
	float	x;
	float	y;
} Vector2f;

typedef struct {
	float	x;
	float	y;
	float	z;
} Vector3f;

typedef struct {
	float	x;
	float	y;
	float	z;
	float	t;
} Vector4f;

#define VECTOR2F_SET( a,b )	\
{.x = a, .y = b}
#define VECTOR3F_SET( a,b,c ) \
{.x = a, .y = b, .z = c}
#define VECTOR4F_SET( a,b,c,d ) \
{.x = a, .y = b, .z = c, .t = d}

void init_Vector2f( Vector2f* self, float x, float y );
void init_Vector3f( Vector3f* self, float x, float y, float z );
void init_Vector4f( Vector4f* self, float x, float y, float z, float t );

void sub_Vector3f( Vector3f* result, Vector3f const* u, Vector3f const* v );
void add_Vector3f( Vector3f* result, Vector3f const* u, Vector3f const* v );
void saturatedAdd_Vector3f( Vector3f* result, Vector3f const* u, Vector3f const* v );
void scale_Vector3f( Vector3f* result, Vector3f const* v, float scale );
float length_Vector3f( Vector3f const* v );
void normalize_Vector3f( Vector3f* result, Vector3f const* v );
void crossProduct_Vector3f( Vector3f* result, Vector3f const* u, Vector3f const* v );

#endif	/* VECTOR_H */

