#ifndef MESH_H
#define MESH_H

#include <containers/vec_.h>
#include <layer.h>
#include <material.h>
#include <texture.h>

#define OWN

typedef enum {
	MESHATTRIBUTE_RECEIVES_SHADOW = (0x1 << 1),
	MESHATTRIBUTE_CASTS_SHADOW = (0x1 << 0)
} MeshAttribute;

typedef struct {
	Vec				layers;		// Vec(Layer)
	float			opacity;
	MeshAttribute	attributes;
} Mesh;

/* interface */
void init_Mesh( Mesh* self );
void destroy_Mesh( Mesh* mesh );
void reset_Mesh( Mesh* mesh );
void setOpacity_Mesh( Mesh* mesh, float opacity );
float getOpacity_Mesh( Mesh const* mesh );
void addLayer_Mesh( Mesh* mesh, OWN Layer* layer );
Vec const* getLayersConst_Mesh( Mesh const* self );
void setAttributes_Mesh( Mesh* self, MeshAttribute attributes );
MeshAttribute getAttributes_Mesh( Mesh const* self );

#endif	/* MESH_H */
