#ifndef SURFACE_H
#define SURFACE_H

#include <types.h>

typedef enum {
	PIXELFMT_RGBA_5551,
	PIXELFMT_16
} PixelFormat;

typedef struct {
	PixelFormat	pixfmt;
	void*		data;
	uint16_t	width;
	uint16_t	height;
} Surface;

void init_Surface( Surface* self, PixelFormat pixfmt, void* data,
	uint16_t width, uint16_t height );
PixelFormat getPixelFormat_Surface( Surface const* self );
void* getData_Surface( Surface const* self );
void const* getValue_Surface( Surface const* self, int16_t x, int16_t y );
uint16_t getWidth_Surface( Surface const* self );
uint16_t getHeight_Surface( Surface const* self );
float getAspectRatio_Surface( Surface const* self );
uint32_t getPixelsNum_Surface( Surface const* self );
uint32_t getSize_Surface( Surface const* self );
bool coordInBounds_Surface( Surface const* self, int16_t x, int16_t y );

#endif	/* SURFACE_H */

