#include <layer.h>
#include <sys/region.h>

inline void init_Layer( Layer* self ) {
	init_Vec( &self->verts, sizeof( Vertex_generic ), ALIGN_DEFAULT, NULL, NULL );
	init_Vec( &self->triangles, sizeof( Triangle ), ALIGN_DEFAULT, NULL, NULL );
	self->material_id = 0;
}

inline void destroy_Layer( Layer* self ) {
	destroy_Vec( &self->triangles );
	destroy_Vec( &self->verts );
}

inline void reset_Layer( Layer* self ) {
	reset_Vec( &self->verts );
	reset_Vec( &self->triangles );
}

inline uint16_t getMaterialId_Layer( Layer const* self ) {
	return self->material_id;
}

inline void setMaterialId_Layer( Layer* self, uint16_t material_id ) {
	self->material_id = material_id;
}

inline void addVertex_Layer( Layer* self, Vertex_generic const* vertex ) {
	pushBack_Vec( &self->verts, vertex );
}

inline void addTriangle_Layer( Layer* self, Triangle const* triangle ) {
	pushBack_Vec( &self->triangles, triangle );
}

inline Vec const* getVerticesConst_Layer( Layer const* self ) {
	return &self->verts;
}

inline Vec const* getTrianglesConst_Layer( Layer const* self ) {
	return &self->triangles;
}
