#include <modeler/modeler.h>

Mesh createPlane_Modeler( void ) {
	Mesh result;
	init_Mesh( &result );

	Layer layer;
	init_Layer( &layer );

	Vertex_generic vts[] = {
		{
			.pos = { .x = -1.0f, .y = -1.0f, .z = 0.0f }, 
			.color = { .x = 0.0f, .y = 0.0f, .z = 0.0f, .t = 1.0f }
		},
		{
			.pos = { .x = 1.0f, .y = -1.0f, .z = 0.0f }, 
			.color = { .x = 0.0f, .y = 0.0f, .z = 0.0f, .t = 1.0f }
		},
		{
			.pos = { .x = 1.0f, .y = 1.0f, .z = 0.0f }, 
			.color = { .x = 0.0f, .y = 0.0f, .z = 0.0f, .t = 1.0f }
		},
		{
			.pos = { .x = -1.0f, .y = 1.0f, .z = 0.0f }, 
			.color = { .x = 0.0f, .y = 0.0f, .z = 0.0f, .t = 1.0f }
		}
	};
	addVertex_Layer( &layer, &vts[0] );
	addVertex_Layer( &layer, &vts[1] );
	addVertex_Layer( &layer, &vts[2] );
	addVertex_Layer( &layer, &vts[3] );

	Triangle tris[] = {
		{
		.ids = { 0, 1, 2 }
		},
		{
		.ids = { 0, 2, 3 }
		}
	};
	addTriangle_Layer( &layer, &tris[0] );
	addTriangle_Layer( &layer, &tris[1] );

	addLayer_Mesh( &result, &layer );

	return result;
}
