#include <abort.h>
#include <malloc.h>
#include <sys/region.h>
#include <sys/nativedl.h>

NativeDL* new_NativeDL( void ) {
	NativeDL* dl = malloc( sizeof(NativeDL) );
	if( NULL == dl ) {
		abort();
	}
	init_NativeDL( dl );
	
	return dl;
}

inline void init_NativeDL( NativeDL* self ) {
	init_Vec( &self->gfx, sizeof(Gfx), ALIGN_8B, NULL, NULL );
}

inline Gfx* getHead_NativeDL( NativeDL* self ) {
	return getElement_Vec( &self->gfx, 0 );
}

inline uint16_t getLength_NativeDL( NativeDL const* self ) {
	return getLength_Vec( &self->gfx );
}

inline void resetCounter_NativeDL( NativeDL* self ) {
	reset_Vec( &self->gfx );
}

inline void addCommand_NativeDL_( NativeDL* self, Gfx cmd ) {
	pushBack_Vec( &self->gfx, &cmd );
}

void addCommands_NativeDL_( NativeDL* self, Gfx cmd[], uint8_t n ) {
	for( uint8_t i=0; i<n; ++i ) {
		addCommand_NativeDL_( self, cmd[i] );
	}
}

inline bool isOverflowed_NativeDL( NativeDL* self ) {
	if(self) {}
	return false;
}

