#include <resmgr/resmgr.h>
#include <sys/sys.h>
#include "img_action.h"
#include "main.h"

static Raw_Xformer			root;
static Camera_Xformer		camera_xf;
static StaticMesh_Xformer	mesh_xf;
static TreeNode				root_node, mesh_node, camera_node;
static Tree					scene_tree;
static Task 				sceneTask = { (taskfptr)sceneTaskF_Engine, &scene_tree };

void init_img_action( Time const* time, void* arg ) {
	if( time ) {}

	ImgActionArgs const* args = (ImgActionArgs const*)arg;
	Engine* engine = args->engine;

	// root
	root = createRaw_Engine( engine );
	init_TreeNode( &root_node, &root, NULL );

	// camera
	camera_xf = createCamera_Engine( engine, ORTHOGRAPHIC_CAMERA );
	/*
	setParams_OrthoCamera( getOrtho_Camera( camera_xf.camera ),
		-10.0f*SCREEN_ASPECT_RATIO, 10.0f*SCREEN_ASPECT_RATIO,
		-10.0f, 10.0f,
		1.33f, 1000.0f
	);
	*/
	setParams_OrthoCamera( getOrtho_Camera( camera_xf.camera ),
		-1.0f, 1.0f,
		-1.0f, 1.0f,
		-1.0f, 1.0f
	);
	init_TreeNode( &camera_node, &camera_xf, NULL );

	// mesh
	StaticMesh* mesh = (StaticMesh*)getResource_ResMgr( "img" );
	mesh_xf = createStaticMesh_Engine( engine, mesh );
	init_TreeNode( &mesh_node, &mesh_xf, NULL );

	// setup hierarchy
	attachChild_TreeNode( &root_node, &mesh_node );
	attachChild_TreeNode( &root_node, &camera_node );

	init_Tree( &scene_tree, &root_node, NULL, NULL );
}

void handle_img_action( Time const* time, void* arg ) {
	if( time ) {}
	return;

	ImgActionArgs* args = (ImgActionArgs*)arg;
	Engine* engine = args->engine;

	setCamera_Engine( engine, &camera_xf );

	//float scale_factor = *((float*)arg);
	static Matrix mv;
	/*
	scale_Matrix( &mv,
		0.2f*sinf( scale_factor/10.0f ) + 2*sinf( scale_factor/100.0f ) + 4.0f,
		2*sinf( scale_factor/100.0f ) + 4.0f,
		1.0f
	);
	transformLocally_Xformer( camera_xf.xf, &mv );
	*/
	translate_Matrix( &mv,
		0.0f, 0.0f, -0.9999999f			// 0xF7EC
	);
	transformLocally_Xformer( mesh_xf.xf, &mv );

	//mesh_xf.static_mesh->opacity = 0.2f*sinf( scale_factor/100.0f ) + 0.5f;

	process_task( &sceneTask );

	// sample Z-buffer
	GfxDevice* gdev = getGfxDevice_Sys();
	waitForGPU_GfxDevice( gdev );

	Surface const* zbuf = getSurface_GfxDevice( gdev, SURFACE_Z );
	uint16_t zdev = *(uint16_t*)getValue_Surface( zbuf, 160, 100 );
	float zval = zAsFloat_GfxDevice( gdev, zdev );
	if( zval >= 0.999f ) {
		//abort();
	}
}
